
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Voyager.Actions.IsoStructureSearch &#8212; PhaserVoyager 0.0.1 documentation</title>
    <link rel="stylesheet" href="../../../_static/sphinxdoc.css" type="text/css" />
    <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../../_static/language_data.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../index.html" accesskey="U">Module code</a> &#187;</li> 
      </ul>
    </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for Voyager.Actions.IsoStructureSearch</h1><div class="highlight"><pre>
<span></span>
<span class="c1">#! /usr/bin/env python</span>
<span class="c1"># -*- coding: utf-8 -*-</span>

<span class="c1">#####################################################################</span>
<span class="c1">#  Copyright and authorship belong to:                              #</span>
<span class="c1">#  @author: Massimo Sammito                                         #</span>
<span class="c1">#  @email: mds83@cam.ac.uk / massimo.sammito@gmail.com              #</span>
<span class="c1">#####################################################################</span>
<span class="c1">#####################################################################</span>
<span class="c1">#                              LICENSE                              #</span>
<span class="c1">#                                                                   #</span>
<span class="c1">#                                                                   #</span>
<span class="c1">#####################################################################</span>

<span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">print_function</span>
<span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">division</span>
<span class="kn">from</span> <span class="nn">future.standard_library</span> <span class="kn">import</span> <span class="n">install_aliases</span>
<span class="kn">from</span> <span class="nn">libtbx.phil</span> <span class="kn">import</span> <span class="n">parse</span>

<span class="n">install_aliases</span><span class="p">()</span>

<span class="kn">import</span> <span class="nn">sys</span><span class="o">,</span><span class="nn">os</span><span class="o">,</span><span class="nn">copy</span>
<span class="kn">import</span> <span class="nn">traceback</span>
<span class="kn">from</span> <span class="nn">voyager_actions</span> <span class="kn">import</span> <span class="n">Action</span>
<span class="kn">import</span> <span class="nn">json</span>

<span class="c1">#DISCLAIMER#</span>
<span class="c1">#This class has been generated automatically through strategy_app.py</span>
<span class="c1">#The app does not verify the correctness of the written code</span>
<span class="c1">#Please validate the class before use and manually inspect and correct any error</span>

<div class="viewcode-block" id="IsoStructureSearch_exception"><a class="viewcode-back" href="../../../Voyager.Actions.IsoStructureSearch.html#Voyager.Actions.IsoStructureSearch.IsoStructureSearch_exception">[docs]</a><span class="k">class</span> <span class="nc">IsoStructureSearch_exception</span><span class="p">(</span><span class="ne">Exception</span><span class="p">):</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">msg</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">(</span><span class="n">IsoStructureSearch_exception</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">msg</span><span class="p">)</span></div>
        
<div class="viewcode-block" id="IsoStructureSearch"><a class="viewcode-back" href="../../../Voyager.Actions.IsoStructureSearch.html#Voyager.Actions.IsoStructureSearch.IsoStructureSearch">[docs]</a><span class="k">class</span> <span class="nc">IsoStructureSearch</span><span class="p">(</span><span class="n">Action</span><span class="p">):</span>
    <span class="n">info_dag_nodes</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;hkl_input&quot;</span><span class="p">:</span><span class="s2">&quot;0&quot;</span><span class="p">,</span><span class="s2">&quot;hkl_output&quot;</span><span class="p">:</span><span class="s2">&quot;1&quot;</span><span class="p">,</span><span class="s2">&quot;model_input&quot;</span><span class="p">:</span><span class="s2">&quot;0&quot;</span><span class="p">,</span><span class="s2">&quot;model_output&quot;</span><span class="p">:</span><span class="s2">&quot;1&quot;</span><span class="p">,</span><span class="s2">&quot;occurrences&quot;</span><span class="p">:</span><span class="s2">&quot;1&quot;</span><span class="p">}</span>
    <span class="n">rule</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;[[&quot;None&quot;]]&quot;&quot;&quot;</span>
    <span class="n">phasertngphil</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;</span>
<span class="s2">&quot;&quot;&quot;</span>
    <span class="n">masterphil</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;voyager.IsoStructureSearch {</span>
<span class="s2">delta_dim = 10</span>
<span class="s2">  .type = int(value_min=0)</span>
<span class="s2">  .expert_level = 0</span>
<span class="s2">  .optional = True</span>
<span class="s2">  .short_caption = Angstrom delta</span>
<span class="s2">  .help = Angstrom delta to the unit cell A,B,C parameters</span>

<span class="s2">delta_angle = 5</span>
<span class="s2">  .type = int(value_min=0)</span>
<span class="s2">  .expert_level = 0</span>
<span class="s2">  .optional = True</span>
<span class="s2">  .short_caption = Degree delta</span>
<span class="s2">  .help = Degree delta to the unit cell alpha,beta,gamma parameters</span>
<span class="s2">max_ncdist = 2.5</span>
<span class="s2">  .type = float(value_min=0)</span>
<span class="s2">  .expert_level = 0</span>
<span class="s2">  .optional = True</span>
<span class="s2">  .short_caption = threhsold distance</span>
<span class="s2">  .help = Maximum NCDIST threhsold to explore</span>
<span class="s2">top_explore = 10</span>
<span class="s2">  .type = int(value_min=0)</span>
<span class="s2">  .expert_level = 0</span>
<span class="s2">  .optional = True</span>
<span class="s2">  .short_caption = Number of top entries</span>
<span class="s2">  .help = Number of top entries to be explored against the intensity correlation check.</span>
<span class="s2">min_corr_coeff = 0.60</span>
<span class="s2">  .type = float(value_min=0.0, value_max=1.0)</span>
<span class="s2">  .expert_level = 0</span>
<span class="s2">  .optional = True</span>
<span class="s2">  .short_caption = CC</span>
<span class="s2">  .help = Intensities Correlation Coefficient of the given dataset vs isostructure entry</span>
<span class="s2">tutorial_mode = False</span>
<span class="s2">  .type = bool</span>
<span class="s2">  .expert_level = 0</span>
<span class="s2">  .optional = True</span>
<span class="s2">  .short_caption = tutorial</span>
<span class="s2">  .help = Does not create a dag node even if a model is found</span>
<span class="s2">}&quot;&quot;&quot;</span>
    <span class="n">helpstring</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot; This action performs a cell search against pdb database and extract data from structures with similar unit cells. Intensity data is correlated to the input mtz to check if it is the same structure. Reindexing is performed if required.&quot;&quot;&quot;</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">strategy</span><span class="p">,</span> <span class="n">current_phil_keywords</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="s1">&#39;IsoStructureSearch&#39;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span> <span class="o">=</span> <span class="n">strategy</span><span class="o">.</span><span class="n">arguments</span>
        <span class="nb">super</span><span class="p">(</span><span class="n">IsoStructureSearch</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">strategy</span><span class="p">,</span> <span class="n">current_phil_keywords</span><span class="p">)</span>
        
        
<div class="viewcode-block" id="IsoStructureSearch.check_imports"><a class="viewcode-back" href="../../../Voyager.Actions.IsoStructureSearch.html#Voyager.Actions.IsoStructureSearch.IsoStructureSearch.check_imports">[docs]</a>    <span class="k">def</span> <span class="nf">check_imports</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">b</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">test</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;test() method has not been implemented!&quot;</span><span class="p">)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">c</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">help</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;help() method has not been implemented!&quot;</span><span class="p">)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">d</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_name</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;get_name() method has not been implemented!&quot;</span><span class="p">)</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">iotbx</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;iotbx&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">fetch</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;iotbx.pdb.fetch&quot;</span><span class="p">,</span><span class="n">fromlist</span><span class="o">=</span><span class="p">[</span><span class="s2">&quot;fetch&quot;</span><span class="p">])</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">cctbx</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;cctbx&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">system_utility</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;system_utility&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">simple_tools</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;simple_tools&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">np</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;numpy&quot;</span><span class="p">)</span>


        <span class="k">return</span> <span class="kc">True</span></div>

<div class="viewcode-block" id="IsoStructureSearch.test"><a class="viewcode-back" href="../../../Voyager.Actions.IsoStructureSearch.html#Voyager.Actions.IsoStructureSearch.IsoStructureSearch.test">[docs]</a>    <span class="k">def</span> <span class="nf">test</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="c1">#TODO: perform a complete self contained test</span>
        <span class="k">pass</span></div>
    
<div class="viewcode-block" id="IsoStructureSearch.help"><a class="viewcode-back" href="../../../Voyager.Actions.IsoStructureSearch.html#Voyager.Actions.IsoStructureSearch.IsoStructureSearch.help">[docs]</a>    <span class="k">def</span> <span class="nf">help</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">helpstring</span></div>
    
<div class="viewcode-block" id="IsoStructureSearch.get_name"><a class="viewcode-back" href="../../../Voyager.Actions.IsoStructureSearch.html#Voyager.Actions.IsoStructureSearch.IsoStructureSearch.get_name">[docs]</a>    <span class="k">def</span> <span class="nf">get_name</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">name</span></div>
    
<div class="viewcode-block" id="IsoStructureSearch.run"><a class="viewcode-back" href="../../../Voyager.Actions.IsoStructureSearch.html#Voyager.Actions.IsoStructureSearch.IsoStructureSearch.run">[docs]</a>    <span class="k">def</span> <span class="nf">run</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">notify_start</span><span class="p">()</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s2">&quot;logger&quot;</span><span class="p">):</span> <span class="k">raise</span> <span class="n">IsoStructureSearch_exception</span><span class="p">(</span><span class="s2">&quot;Logger File has not been set. Please call &#39;set_logger_file&#39; method before run&quot;</span><span class="p">)</span>
        <span class="n">user_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">python_object</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span><span class="p">)</span>
        <span class="n">diffuser_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch_diff</span><span class="p">(</span><span class="n">source</span><span class="o">=</span><span class="n">user_phil</span><span class="p">)</span>
        <span class="n">action_phil</span> <span class="o">=</span> <span class="n">parse</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">current_phil_keywords</span><span class="p">)</span>
        <span class="n">diffaction_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch_diff</span><span class="p">(</span><span class="n">source</span><span class="o">=</span><span class="n">action_phil</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch</span><span class="p">(</span><span class="n">sources</span><span class="o">=</span><span class="p">[</span><span class="n">diffaction_phil</span><span class="p">,</span> <span class="n">diffuser_phil</span><span class="p">])</span><span class="o">.</span><span class="n">extract</span><span class="p">()</span>
        <span class="n">output</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">isostructure_search</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">notify_end</span><span class="p">()</span>
        <span class="k">return</span> <span class="n">output</span></div>

<div class="viewcode-block" id="IsoStructureSearch.isostructure_search"><a class="viewcode-back" href="../../../Voyager.Actions.IsoStructureSearch.html#Voyager.Actions.IsoStructureSearch.IsoStructureSearch.isostructure_search">[docs]</a>    <span class="k">def</span> <span class="nf">isostructure_search</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">argsparse</span><span class="p">):</span>
        <span class="n">root</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">initial_dag_nodes</span>
        <span class="k">if</span> <span class="n">root</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span> <span class="n">root</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">root</span><span class="p">,</span> <span class="nb">list</span><span class="p">)</span> <span class="ow">and</span> <span class="nb">len</span><span class="p">(</span><span class="n">root</span><span class="p">)</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span> <span class="n">root</span> <span class="o">=</span> <span class="n">root</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
        <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">root</span><span class="p">,</span> <span class="nb">list</span><span class="p">)</span> <span class="ow">and</span> <span class="nb">len</span><span class="p">(</span><span class="n">root</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">1</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">error</span><span class="p">(</span><span class="s2">&quot;This action only support one single input dag node&quot;</span><span class="p">)</span>
            <span class="k">raise</span> <span class="n">IsoStructureSearch_exception</span><span class="p">(</span><span class="s2">&quot;This action only support one single input dag node&quot;</span><span class="p">)</span>

        <span class="n">mtz</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">reflections</span>

        <span class="k">if</span> <span class="n">mtz</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">mtz</span><span class="p">):</span>
            <span class="n">mtzobj</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">iotbx</span><span class="o">.</span><span class="n">file_reader</span><span class="o">.</span><span class="n">any_file</span><span class="p">(</span><span class="n">mtz</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">raise</span> <span class="n">IsoStructureSearch_exception</span><span class="p">(</span><span class="s2">&quot;FATAL ERROR. The path to the mtz inserted does not correspond to a valid reflection file. Please correct and restart the program.&quot;</span><span class="p">)</span>

        <span class="c1">#TODO: Look into xtriage how it computes the most probable space group</span>
        <span class="c1">#TODO: This only if requested and activated as a phil parameter</span>
        <span class="c1">#TODO: phenix.xtriage name.mtz</span>
        <span class="c1">#TODO: phenix.reflection_file_converter c2.sca --change_of_basis=to_niggli_cell --sca=niggli.sca</span>
        <span class="c1">#TODO: phenix.reflection_file_converter niggli.sca --change_to_space_group=R32:R --sca=r32r.sca</span>
        <span class="c1">#TODO: phenix.reflection_file_converter r32r.sca --change_of_basis=to_reference_setting --sca=r32_hexagonal_setting.sca</span>

        <span class="c1">#TODO: If Data analysis has been performed I should check if Have twinning to get the different lattices and use the two different unit cells as two alternatives</span>

        <span class="n">niggli_cell</span> <span class="o">=</span> <span class="n">mtzobj</span><span class="o">.</span><span class="n">crystal_symmetry</span><span class="p">()</span><span class="o">.</span><span class="n">niggli_cell</span><span class="p">()</span><span class="o">.</span><span class="n">unit_cell</span><span class="p">()</span><span class="o">.</span><span class="n">parameters</span><span class="p">()</span>
        <span class="n">reciprocal_cell</span> <span class="o">=</span> <span class="n">mtzobj</span><span class="o">.</span><span class="n">crystal_symmetry</span><span class="p">()</span><span class="o">.</span><span class="n">unit_cell</span><span class="p">()</span><span class="o">.</span><span class="n">reciprocal_parameters</span><span class="p">()</span>
        <span class="n">unit_cell_volume</span> <span class="o">=</span> <span class="n">mtzobj</span><span class="o">.</span><span class="n">crystal_symmetry</span><span class="p">()</span><span class="o">.</span><span class="n">unit_cell</span><span class="p">()</span><span class="o">.</span><span class="n">niggli_cell</span><span class="p">()</span><span class="o">.</span><span class="n">volume</span><span class="p">()</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;ORIGINAL CELL: &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">mtzobj</span><span class="o">.</span><span class="n">crystal_symmetry</span><span class="p">()</span><span class="o">.</span><span class="n">unit_cell</span><span class="p">()</span><span class="o">.</span><span class="n">parameters</span><span class="p">()))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;NIGGLI CELL: &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">niggli_cell</span><span class="p">))</span>
    
        <span class="n">delta_dim</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">IsoStructureSearch</span><span class="o">.</span><span class="n">delta_dim</span>
        <span class="n">delta_angle</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">IsoStructureSearch</span><span class="o">.</span><span class="n">delta_angle</span>
    
        <span class="n">min_a</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">niggli_cell</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">-</span> <span class="n">delta_dim</span><span class="p">)</span>
        <span class="n">max_a</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">niggli_cell</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="n">delta_dim</span><span class="p">)</span>
        <span class="n">min_b</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">niggli_cell</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">-</span> <span class="n">delta_dim</span><span class="p">)</span>
        <span class="n">max_b</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">niggli_cell</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">+</span> <span class="n">delta_dim</span><span class="p">)</span>
        <span class="n">min_c</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">niggli_cell</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span> <span class="o">-</span> <span class="n">delta_dim</span><span class="p">)</span>
        <span class="n">max_c</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">niggli_cell</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span> <span class="o">+</span> <span class="n">delta_dim</span><span class="p">)</span>
        <span class="n">min_alpha</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">niggli_cell</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span> <span class="o">-</span> <span class="n">delta_angle</span><span class="p">)</span>
        <span class="n">max_alpha</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">niggli_cell</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span> <span class="o">+</span> <span class="n">delta_angle</span><span class="p">)</span>
        <span class="n">min_beta</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">niggli_cell</span><span class="p">[</span><span class="mi">4</span><span class="p">]</span> <span class="o">-</span> <span class="n">delta_angle</span><span class="p">)</span>
        <span class="n">max_beta</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">niggli_cell</span><span class="p">[</span><span class="mi">4</span><span class="p">]</span> <span class="o">+</span> <span class="n">delta_angle</span><span class="p">)</span>
        <span class="n">min_gamma</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">niggli_cell</span><span class="p">[</span><span class="mi">5</span><span class="p">]</span> <span class="o">-</span> <span class="n">delta_angle</span><span class="p">)</span>
        <span class="n">max_gamma</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">niggli_cell</span><span class="p">[</span><span class="mi">5</span><span class="p">]</span> <span class="o">+</span> <span class="n">delta_angle</span><span class="p">)</span>
    
        <span class="c1"># print(&quot;TEST&quot;)</span>
        <span class="c1"># UC1 = cctbx.uctbx.unit_cell([80.36, 80.36, 99.44, 90, 90, 120]).niggli_cell().parameters() #1U4J</span>
        <span class="c1"># UC2 = cctbx.uctbx.unit_cell([80.360 ,  80.360  , 99.440 , 90.00 , 90.00 ,120.00]).niggli_cell().parameters() #1G07</span>
        <span class="c1"># UC3 = cctbx.uctbx.unit_cell([55.120,   55.120 ,  54.810 , 90.00 , 90.00 , 90.00]).niggli_cell().parameters() #2SGA</span>
        <span class="c1"># UC4 = cctbx.uctbx.unit_cell([80.949 ,  80.572  , 57.098 , 90.00 , 90.35 , 90.00]).niggli_cell().parameters() #1G2X</span>
        <span class="c1">#</span>
        <span class="c1"># print(&quot;1U4J&quot;,UC1,&quot;1G07&quot;,UC2)</span>
        <span class="c1"># print(&quot;NCDist&quot;,simple_tools.NCDist_metric(UC1).NCDist(UC2),&quot;annotated&quot;,0.0)</span>
        <span class="c1"># print(&quot;cctbx NCDist&quot;,np.sqrt(NCDist(simple_tools.g6_form(UC1),simple_tools.g6_form(UC2)))*(np.sqrt(6.0)/np.mean(UC1[:3]+UC2[:3])))</span>
        <span class="c1"># print(&quot;V7&quot;,simple_tools.V7(UC1).V7_distance(UC2),&quot;annotated&quot;,0.0)</span>
        <span class="c1"># print()</span>
        <span class="c1"># print(&quot;1U4J&quot;, UC1, &quot;2SGA&quot;, UC3)</span>
        <span class="c1"># print(&quot;NCDist&quot;, simple_tools.NCDist_metric(UC1).NCDist(UC3),&quot;annotated&quot;,3.1)</span>
        <span class="c1"># print(&quot;cctbx NCDist&quot;,np.sqrt(NCDist(simple_tools.g6_form(UC1),simple_tools.g6_form(UC3)))*(np.sqrt(6.0)/np.mean(UC1[:3]+UC3[:3])))</span>
        <span class="c1"># print(&quot;V7&quot;, simple_tools.V7(UC1).V7_distance(UC3),&quot;annotated&quot;,4.9)</span>
        <span class="c1"># print()</span>
        <span class="c1"># print(&quot;1U4J&quot;, UC1, &quot;1G2X&quot;, UC4)</span>
        <span class="c1"># print(&quot;NCDist&quot;, simple_tools.NCDist_metric(UC1).NCDist(UC4),&quot;annotated&quot;,0.9)</span>
        <span class="c1"># print(&quot;cctbx NCDist&quot;,np.sqrt(NCDist(simple_tools.g6_form(UC1),simple_tools.g6_form(UC4)))*(np.sqrt(6.0)/np.mean(UC1[:3]+UC4[:3])))</span>
        <span class="c1"># print(&quot;V7&quot;, simple_tools.V7(UC1).V7_distance(UC4),&quot;annotated&quot;,0.2)</span>
        <span class="c1"># print()</span>
    
        <span class="c1"># cell_search = &quot;https://www.ebi.ac.uk/pdbe/search/pdb/select?q=nigli_cell_a:[&quot; + min_a + &quot;%20TO%20&quot; + max_a + &quot;]%20AND%20nigli_cell_b:[&quot; + min_b + &quot;%20TO%20&quot; + max_b + &quot;]%20AND%20nigli_cell_c:[&quot; + min_c + &quot;%20TO%20&quot; + max_c + &quot;]%20AND%20nigli_cell_alpha:[&quot; + min_alpha + &quot;%20TO%20&quot; + max_alpha + &quot;]%20AND%20nigli_cell_beta:[&quot; + min_beta + &quot;%20TO%20&quot; + max_beta + &quot;]%20AND%20nigli_cell_gamma:[&quot; + min_gamma + &quot;%20TO%20&quot; + max_gamma + &quot;]&amp;group=true&amp;group.field=pdb_id&amp;rows=100000&amp;group.ngroups=true&amp;omitHeader=true&amp;fl=*&quot;</span>
        <span class="n">cell_search</span> <span class="o">=</span> <span class="s2">&quot;https://wwwdev.ebi.ac.uk/pdbe/search/pdb/select?q=nigli_cell_a:[&quot;</span> <span class="o">+</span> <span class="n">min_a</span> <span class="o">+</span> <span class="s2">&quot;%20TO%20&quot;</span> <span class="o">+</span> <span class="n">max_a</span> <span class="o">+</span> <span class="s2">&quot;]%20AND%20nigli_cell_b:[&quot;</span> <span class="o">+</span> <span class="n">min_b</span> <span class="o">+</span> <span class="s2">&quot;%20TO%20&quot;</span> <span class="o">+</span> <span class="n">max_b</span> <span class="o">+</span> <span class="s2">&quot;]%20AND%20nigli_cell_c:[&quot;</span> <span class="o">+</span> <span class="n">min_c</span> <span class="o">+</span> <span class="s2">&quot;%20TO%20&quot;</span> <span class="o">+</span> <span class="n">max_c</span> <span class="o">+</span> <span class="s2">&quot;]%20AND%20nigli_cell_alpha:[&quot;</span> <span class="o">+</span> <span class="n">min_alpha</span> <span class="o">+</span> <span class="s2">&quot;%20TO%20&quot;</span> <span class="o">+</span> <span class="n">max_alpha</span> <span class="o">+</span> <span class="s2">&quot;]%20AND%20nigli_cell_beta:[&quot;</span> <span class="o">+</span> <span class="n">min_beta</span> <span class="o">+</span> <span class="s2">&quot;%20TO%20&quot;</span> <span class="o">+</span> <span class="n">max_beta</span> <span class="o">+</span> <span class="s2">&quot;]%20AND%20nigli_cell_gamma:[&quot;</span> <span class="o">+</span> <span class="n">min_gamma</span> <span class="o">+</span> <span class="s2">&quot;%20TO%20&quot;</span> <span class="o">+</span> <span class="n">max_gamma</span> <span class="o">+</span> <span class="s2">&quot;]&amp;group=true&amp;group.field=pdb_id&amp;rows=100000&amp;group.ngroups=true&amp;omitHeader=true&amp;fl=*&quot;</span>

        <span class="n">z</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">system_utility</span><span class="o">.</span><span class="n">request_url</span><span class="p">(</span><span class="n">cell_search</span><span class="p">,</span> <span class="s2">&quot;www.ebi.ac.uk&quot;</span><span class="p">)</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;UNIT CELL search &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">cell_search</span><span class="p">))</span>
    
        <span class="k">if</span> <span class="ow">not</span> <span class="n">z</span><span class="p">:</span>
            <span class="n">result_list</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">a1</span><span class="p">,</span> <span class="n">b1</span><span class="p">,</span> <span class="n">c1</span><span class="p">,</span> <span class="n">alpha1</span><span class="p">,</span> <span class="n">beta1</span><span class="p">,</span> <span class="n">gamma1</span> <span class="o">=</span> <span class="n">niggli_cell</span>
            <span class="n">resu</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">z</span><span class="p">)</span>
            <span class="n">result_list</span> <span class="o">=</span> <span class="p">[[</span><span class="n">gr</span><span class="p">[</span><span class="s2">&quot;groupValue&quot;</span><span class="p">],</span> <span class="p">[(</span><span class="n">s</span><span class="p">[</span><span class="s2">&quot;nigli_cell_a&quot;</span><span class="p">],</span> <span class="n">s</span><span class="p">[</span><span class="s2">&quot;nigli_cell_b&quot;</span><span class="p">],</span> <span class="n">s</span><span class="p">[</span><span class="s2">&quot;nigli_cell_c&quot;</span><span class="p">],</span>
                                                <span class="n">s</span><span class="p">[</span><span class="s2">&quot;nigli_cell_alpha&quot;</span><span class="p">],</span> <span class="n">s</span><span class="p">[</span><span class="s2">&quot;nigli_cell_beta&quot;</span><span class="p">],</span> <span class="n">s</span><span class="p">[</span><span class="s2">&quot;nigli_cell_gamma&quot;</span><span class="p">])</span> <span class="k">for</span>
                                               <span class="n">s</span> <span class="ow">in</span> <span class="n">gr</span><span class="p">[</span><span class="s2">&quot;doclist&quot;</span><span class="p">][</span><span class="s2">&quot;docs&quot;</span><span class="p">]][</span><span class="mi">0</span><span class="p">]]</span> <span class="k">for</span> <span class="n">gr</span> <span class="ow">in</span>
                           <span class="n">resu</span><span class="p">[</span><span class="s2">&quot;grouped&quot;</span><span class="p">][</span><span class="s2">&quot;pdb_id&quot;</span><span class="p">][</span><span class="s2">&quot;groups&quot;</span><span class="p">]]</span>
            <span class="n">UC1</span> <span class="o">=</span> <span class="p">[</span><span class="n">a1</span><span class="p">,</span> <span class="n">b1</span><span class="p">,</span> <span class="n">c1</span><span class="p">,</span> <span class="n">alpha1</span> <span class="o">/</span> <span class="mf">57.2957795130823</span><span class="p">,</span> <span class="n">beta1</span> <span class="o">/</span> <span class="mf">57.2957795130823</span><span class="p">,</span> <span class="n">gamma1</span> <span class="o">/</span> <span class="mf">57.2957795130823</span><span class="p">]</span>
            <span class="c1"># v7 = simple_tools.V7(UC1)</span>
            <span class="n">rsn</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="k">for</span> <span class="n">resu</span> <span class="ow">in</span> <span class="n">result_list</span><span class="p">:</span>
                <span class="n">pdbid</span><span class="p">,</span> <span class="n">niggli</span> <span class="o">=</span> <span class="n">resu</span>
                <span class="n">a2</span><span class="p">,</span> <span class="n">b2</span><span class="p">,</span> <span class="n">c2</span><span class="p">,</span> <span class="n">alpha2</span><span class="p">,</span> <span class="n">beta2</span><span class="p">,</span> <span class="n">gamma2</span> <span class="o">=</span> <span class="n">niggli</span>
                <span class="c1"># ncdist = simple_tools.NCDist_metric([a1, b1, c1, alpha1, beta1, gamma1])</span>
                <span class="c1"># dist = ncdist.NCDist([a2, b2, c2, alpha2, beta2, gamma2])</span>
                <span class="n">UC2</span> <span class="o">=</span> <span class="p">[</span><span class="n">a2</span><span class="p">,</span> <span class="n">b2</span><span class="p">,</span> <span class="n">c2</span><span class="p">,</span> <span class="n">alpha2</span> <span class="o">/</span> <span class="mf">57.2957795130823</span><span class="p">,</span> <span class="n">beta2</span> <span class="o">/</span> <span class="mf">57.2957795130823</span><span class="p">,</span> <span class="n">gamma2</span> <span class="o">/</span> <span class="mf">57.2957795130823</span><span class="p">]</span>
                <span class="c1"># UC1 = [145.9, 145.9, 191.645, 90, 112.374, 120]</span>
                <span class="c1"># UC2 = [145.097, 145.097, 190.011, 90, 112.446, 120]</span>
                <span class="c1"># distv7 = v7.V7_distance(UC2)</span>
                <span class="c1"># cctbx_ncdist = np.sqrt(NCDist(simple_tools.g6_form(UC1),simple_tools.g6_form(UC2)))*(np.sqrt(6.0)/np.mean(UC1[:3]+UC2[:3]))</span>
                <span class="c1"># cctbx_ncdist = NCDist(UC1, UC2)  # /np.mean(np.abs(np.array(UC1[:3])-np.array(UC2[:3])))</span>
                <span class="n">cctbx_ncdist</span> <span class="o">=</span> <span class="mf">0.1</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">cctbx</span><span class="o">.</span><span class="n">uctbx</span><span class="o">.</span><span class="n">determine_unit_cell</span><span class="o">.</span><span class="n">NCDist</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">simple_tools</span><span class="o">.</span><span class="n">g6_form</span><span class="p">(</span><span class="n">UC1</span><span class="p">),</span> <span class="bp">self</span><span class="o">.</span><span class="n">simple_tools</span><span class="o">.</span><span class="n">g6_form</span><span class="p">(</span><span class="n">UC2</span><span class="p">)))</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Cell distance &quot;</span><span class="o">+</span><span class="n">pdbid</span><span class="o">+</span><span class="s2">&quot; &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">niggli_cell</span><span class="p">)</span><span class="o">+</span><span class="s2">&quot; and &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">niggli</span><span class="p">))</span>
                <span class="c1"># print(&quot;NCDIST&quot;,dist)</span>
                <span class="c1"># print(&quot;V7&quot; ,distv7)</span>
                <span class="c1"># print(UC1)</span>
                <span class="c1"># print(UC2)</span>
                <span class="c1"># print(&quot;CCTBX NCDIST&quot;, cctbx_ncdist, NCDist(simple_tools.g6_form(UC1), simple_tools.g6_form(UC2)), NCDist(UC1, UC2))</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;CCTBX NCDIST &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">cctbx_ncdist</span><span class="p">))</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;&quot;</span><span class="p">)</span>
                <span class="c1"># quit()</span>
                <span class="n">rsn</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">pdbid</span><span class="p">,</span> <span class="n">cctbx_ncdist</span><span class="p">))</span>
    
            <span class="n">result_list</span> <span class="o">=</span> <span class="nb">sorted</span><span class="p">(</span><span class="n">rsn</span><span class="p">,</span> <span class="n">key</span><span class="o">=</span><span class="k">lambda</span> <span class="n">x</span><span class="p">:</span> <span class="n">x</span><span class="p">[</span><span class="mi">1</span><span class="p">])</span>
    
        <span class="n">ic</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">simple_tools</span><span class="o">.</span><span class="n">Intensity_Correlation</span><span class="p">(</span><span class="n">mtz</span><span class="p">)</span>
    
        <span class="n">foundpdb</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="n">maxcc</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="n">ope</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
        <span class="n">MAXNCDIST</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">IsoStructureSearch</span><span class="o">.</span><span class="n">max_ncdist</span> <span class="c1"># NOTE: 2.5   This is the default of SAUC server</span>
        <span class="n">TOPEXPLORE</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">IsoStructureSearch</span><span class="o">.</span><span class="n">top_explore</span> <span class="c1">#10</span>
        <span class="n">MINCCTHRESH</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">IsoStructureSearch</span><span class="o">.</span><span class="n">min_corr_coeff</span> <span class="c1">#0.60</span>
        <span class="n">topnlist</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">r</span><span class="p">,</span> <span class="p">(</span><span class="n">pdbid</span><span class="p">,</span> <span class="n">dist</span><span class="p">)</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">result_list</span><span class="p">):</span>
            <span class="c1">#print(&quot;Evaluating &quot;,r,pdbid,dist)</span>
            <span class="k">if</span> <span class="n">dist</span> <span class="o">&gt;=</span> <span class="n">MAXNCDIST</span><span class="p">:</span> <span class="k">break</span>
    
            <span class="n">z</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">system_utility</span><span class="o">.</span><span class="n">request_url</span><span class="p">(</span><span class="s2">&quot;https://www.ebi.ac.uk/pdbe/api/pdb/entry/summary/&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">pdbid</span><span class="o">.</span><span class="n">lower</span><span class="p">()),</span> <span class="s2">&quot;www.ebi.ac.uk&quot;</span><span class="p">)</span>
            <span class="k">if</span> <span class="ow">not</span> <span class="n">z</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Skipping &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">pdbid</span><span class="o">.</span><span class="n">lower</span><span class="p">()))</span>
                <span class="k">continue</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">infol</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">z</span><span class="p">)</span>
    
            <span class="n">cannot_download</span> <span class="o">=</span> <span class="kc">False</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Found a pdb structure with similar unit cell parameters and NCDist &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">dist</span><span class="p">))</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;pdbid: &quot;</span><span class="o">+</span> <span class="n">pdbid</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span><span class="o">+</span><span class="s2">&quot; &quot;</span><span class="o">+</span><span class="n">infol</span><span class="p">[</span><span class="n">pdbid</span><span class="o">.</span><span class="n">lower</span><span class="p">()][</span><span class="mi">0</span><span class="p">][</span><span class="s2">&quot;title&quot;</span><span class="p">])</span>
    
            <span class="k">try</span><span class="p">:</span>
                <span class="n">datap</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">fetch</span><span class="o">.</span><span class="n">fetch</span><span class="p">(</span><span class="n">pdbid</span><span class="o">.</span><span class="n">lower</span><span class="p">(),</span> <span class="n">data_type</span><span class="o">=</span><span class="s2">&quot;xray&quot;</span><span class="p">,</span> <span class="nb">format</span><span class="o">=</span><span class="s2">&quot;cif&quot;</span><span class="p">,</span> <span class="n">mirror</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">mirror</span><span class="p">,</span> <span class="n">log</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
                              <span class="n">force_download</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">local_cache</span><span class="o">=</span><span class="kc">None</span><span class="p">)</span><span class="o">.</span><span class="n">read</span><span class="p">()</span><span class="o">.</span><span class="n">decode</span><span class="p">(</span><span class="n">system_utility</span><span class="o">.</span><span class="n">get_encoding</span><span class="p">())</span>
                <span class="c1"># print(sys.exc_info())</span>
                <span class="c1"># traceback.print_exc(file=sys.stdout)</span>
            <span class="k">except</span><span class="p">:</span>
                <span class="k">try</span><span class="p">:</span>
                    <span class="n">datap</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">fetch</span><span class="o">.</span><span class="n">fetch</span><span class="p">(</span><span class="n">pdbid</span><span class="o">.</span><span class="n">lower</span><span class="p">(),</span> <span class="n">data_type</span><span class="o">=</span><span class="s2">&quot;xray&quot;</span><span class="p">,</span> <span class="nb">format</span><span class="o">=</span><span class="s2">&quot;cif&quot;</span><span class="p">,</span> <span class="n">mirror</span><span class="o">=</span><span class="s2">&quot;pdbe&quot;</span><span class="p">,</span> <span class="n">log</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
                                  <span class="n">force_download</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">local_cache</span><span class="o">=</span><span class="kc">None</span><span class="p">)</span><span class="o">.</span><span class="n">read</span><span class="p">()</span><span class="o">.</span><span class="n">decode</span><span class="p">(</span><span class="n">system_utility</span><span class="o">.</span><span class="n">get_encoding</span><span class="p">())</span>
                <span class="k">except</span><span class="p">:</span>
                    <span class="c1"># print(sys.exc_info())</span>
                    <span class="c1"># traceback.print_exc(file=sys.stdout)</span>
                    <span class="n">cannot_download</span> <span class="o">=</span> <span class="kc">True</span>
    
            <span class="c1"># NOTE: It looks like cctbx needs to a filename associated with the cif file string</span>
            <span class="c1"># dp = cStringIO.StringIO(datap)</span>
            <span class="k">if</span> <span class="ow">not</span> <span class="n">cannot_download</span><span class="p">:</span>
                <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">pdbid</span> <span class="o">+</span> <span class="s2">&quot;.cif&quot;</span><span class="p">,</span> <span class="s2">&quot;w&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">fg</span><span class="p">:</span>
                    <span class="n">fg</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="n">datap</span><span class="p">)</span>
                <span class="k">try</span><span class="p">:</span>
                    <span class="k">if</span> <span class="n">ic</span><span class="o">.</span><span class="n">compare</span><span class="p">(</span><span class="n">pdbid</span> <span class="o">+</span> <span class="s2">&quot;.cif&quot;</span><span class="p">,</span> <span class="n">thresh</span><span class="o">=</span><span class="n">MINCCTHRESH</span><span class="p">)</span> <span class="ow">and</span> <span class="n">ic</span><span class="o">.</span><span class="n">cc</span> <span class="o">&gt;</span> <span class="n">maxcc</span><span class="p">:</span>
                        <span class="n">foundpdb</span> <span class="o">=</span> <span class="n">infol</span>
                        <span class="n">maxcc</span> <span class="o">=</span> <span class="n">ic</span><span class="o">.</span><span class="n">cc</span>
                        <span class="n">ope</span> <span class="o">=</span> <span class="n">ic</span><span class="o">.</span><span class="n">operation</span>
                        <span class="n">miller_indexed</span> <span class="o">=</span> <span class="n">copy</span><span class="o">.</span><span class="n">deepcopy</span><span class="p">(</span><span class="n">ic</span><span class="o">.</span><span class="n">miller_indexed</span><span class="p">)</span>
                        <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;The deposited data associated to the structure shows a CC of &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">ic</span><span class="o">.</span><span class="n">cc</span><span class="p">)</span><span class="o">+</span><span class="s2">&quot; against the given data&quot;</span><span class="p">)</span>
                        <span class="n">topnlist</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">pdbid</span><span class="p">,</span> <span class="n">copy</span><span class="o">.</span><span class="n">deepcopy</span><span class="p">(</span><span class="n">ic</span><span class="o">.</span><span class="n">cc</span><span class="p">),</span> <span class="n">copy</span><span class="o">.</span><span class="n">deepcopy</span><span class="p">(</span><span class="n">ic</span><span class="o">.</span><span class="n">operation</span><span class="p">)))</span>
                <span class="k">except</span><span class="p">:</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;CIF of PDB: &quot;</span><span class="o">+</span><span class="n">pdbid</span><span class="o">+</span><span class="s2">&quot; cannot be correctly interpreted. Skipping...&quot;</span><span class="p">)</span>

                <span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">pdbid</span> <span class="o">+</span> <span class="s2">&quot;.cif&quot;</span><span class="p">):</span>
                    <span class="n">os</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">pdbid</span> <span class="o">+</span> <span class="s2">&quot;.cif&quot;</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">foundpdb</span> <span class="ow">and</span> <span class="n">r</span> <span class="o">&gt;=</span> <span class="n">TOPEXPLORE</span><span class="p">:</span> <span class="k">break</span>

        <span class="k">if</span> <span class="n">foundpdb</span><span class="p">:</span>
            <span class="n">tpnl</span> <span class="o">=</span> <span class="p">[(</span><span class="n">v</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">v</span><span class="p">[</span><span class="mi">1</span><span class="p">],</span> <span class="n">v</span><span class="p">[</span><span class="mi">2</span><span class="p">],</span> <span class="kc">True</span> <span class="k">if</span> <span class="n">v</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">==</span> <span class="n">maxcc</span> <span class="k">else</span> <span class="kc">False</span><span class="p">)</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">topnlist</span><span class="p">]</span>
            <span class="n">tpn</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;type&quot;</span><span class="p">:</span> <span class="s2">&quot;celldim&quot;</span><span class="p">,</span> <span class="s2">&quot;list&quot;</span><span class="p">:</span> <span class="n">tpnl</span><span class="p">}</span>
            <span class="n">dictio</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;foundpdb&quot;</span><span class="p">:</span> <span class="n">foundpdb</span><span class="p">,</span> <span class="s2">&quot;cc&quot;</span><span class="p">:</span> <span class="n">maxcc</span><span class="p">,</span> <span class="s2">&quot;operation&quot;</span><span class="p">:</span> <span class="n">ope</span><span class="p">,</span> <span class="s2">&quot;topndict&quot;</span><span class="p">:</span> <span class="n">tpn</span><span class="p">}</span>
    
            <span class="k">if</span> <span class="n">ope</span> <span class="o">!=</span> <span class="s2">&quot;h,k,l&quot;</span><span class="p">:</span>
                <span class="c1"># TODO: Should I do something with the reindexed ic.miller? Maybe rewriting the data following that indexing?</span>
                <span class="k">pass</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Found &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="n">foundpdb</span><span class="o">.</span><span class="n">keys</span><span class="p">())[</span><span class="mi">0</span><span class="p">])</span><span class="o">+</span><span class="s2">&quot; CC &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">dictio</span><span class="p">[</span><span class="s2">&quot;cc&quot;</span><span class="p">])</span><span class="o">+</span><span class="s2">&quot; millers reindexed &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">miller_indexed</span><span class="p">))</span>
    
            <span class="n">cannot_download</span> <span class="o">=</span> <span class="kc">False</span>
            <span class="n">datap</span> <span class="o">=</span> <span class="kc">None</span>
            <span class="n">pdbid</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">foundpdb</span><span class="o">.</span><span class="n">keys</span><span class="p">())[</span><span class="mi">0</span><span class="p">]</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="n">datap</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">fetch</span><span class="o">.</span><span class="n">fetch</span><span class="p">(</span><span class="n">pdbid</span><span class="o">.</span><span class="n">lower</span><span class="p">(),</span> <span class="n">data_type</span><span class="o">=</span><span class="s2">&quot;pdb&quot;</span><span class="p">,</span> <span class="nb">format</span><span class="o">=</span><span class="s2">&quot;pdb&quot;</span><span class="p">,</span> <span class="n">mirror</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">mirror</span><span class="p">,</span> <span class="n">log</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
                                         <span class="n">force_download</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">local_cache</span><span class="o">=</span><span class="kc">None</span><span class="p">)</span><span class="o">.</span><span class="n">read</span><span class="p">()</span><span class="o">.</span><span class="n">decode</span><span class="p">(</span><span class="n">system_utility</span><span class="o">.</span><span class="n">get_encoding</span><span class="p">())</span>
                <span class="c1"># print(sys.exc_info())</span>
                <span class="c1"># traceback.print_exc(file=sys.stdout)</span>
            <span class="k">except</span><span class="p">:</span>
                <span class="k">try</span><span class="p">:</span>
                    <span class="n">datap</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">fetch</span><span class="o">.</span><span class="n">fetch</span><span class="p">(</span><span class="n">pdbid</span><span class="o">.</span><span class="n">lower</span><span class="p">(),</span> <span class="n">data_type</span><span class="o">=</span><span class="s2">&quot;pdb&quot;</span><span class="p">,</span> <span class="nb">format</span><span class="o">=</span><span class="s2">&quot;pdb&quot;</span><span class="p">,</span> <span class="n">mirror</span><span class="o">=</span><span class="s2">&quot;pdbe&quot;</span><span class="p">,</span> <span class="n">log</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
                                             <span class="n">force_download</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">local_cache</span><span class="o">=</span><span class="kc">None</span><span class="p">)</span><span class="o">.</span><span class="n">read</span><span class="p">()</span><span class="o">.</span><span class="n">decode</span><span class="p">(</span><span class="n">system_utility</span><span class="o">.</span><span class="n">get_encoding</span><span class="p">())</span>
                <span class="k">except</span><span class="p">:</span>
                    <span class="c1"># print(sys.exc_info())</span>
                    <span class="c1"># traceback.print_exc(file=sys.stdout)</span>
                    <span class="n">cannot_download</span> <span class="o">=</span> <span class="kc">True</span>
    
            <span class="k">if</span> <span class="ow">not</span> <span class="n">cannot_download</span> <span class="ow">and</span> <span class="ow">not</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">IsoStructureSearch</span><span class="o">.</span><span class="n">tutorial_mode</span><span class="p">:</span>
                <span class="n">pdbpath</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">phasertng_dir</span><span class="p">,</span> <span class="n">pdbid</span> <span class="o">+</span> <span class="s2">&quot;.pdb&quot;</span><span class="p">)</span>
                <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">pdbpath</span><span class="p">,</span> <span class="s2">&quot;w&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">fg</span><span class="p">:</span>
                    <span class="n">fg</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="n">datap</span><span class="p">)</span>
                <span class="k">return</span> <span class="p">[</span><span class="n">x</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">schedule_add_node_model</span><span class="p">(</span><span class="n">pdbpath</span><span class="p">,</span> <span class="s2">&quot;isostructure&quot;</span><span class="p">,</span> <span class="n">dictio</span><span class="p">,</span> <span class="n">root</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">associated_strategy_node</span><span class="p">)]</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">initial_dag_nodes</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">initial_dag_nodes</span></div></div>
</pre></div>

          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../index.html" >Module code</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2020, Massimo D. Sammito.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.8.5.
    </div>
  </body>
</html>